<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class>
      <h1>Jobs</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">
          <i class="mdi mdi-home-outline"></i>
        </el-breadcrumb-item>
        <el-breadcrumb-item>Jobs</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <br />
    <el-card>
      <el-select
        v-model="verifyValue"
        @change="changeVerifyFilter"
        class
      >
        <el-option
          v-for="item in verifyOptions"
          :key="item.value"
          :label="item.label"
          :value="item.value"
        ></el-option>
      </el-select>

      <!-- <el-select
        v-model="category_id"
        @change="changeVerifyFilter"
        class="CategoryFillter"
        placeholder="All category"
      >
        <el-option v-for="item in categories" :key="item.id" :label="item.name" :value="item.id"></el-option>
      </el-select>-->
      <!-- category select group -->
      <el-select
        v-model="category_ids"
        @change="CategoryFillter"
        multiple
        collapse-tags
        clearable
        class="categoryfillter"
        placeholder="All category"
      >
        <el-option
          v-for="item in categories"
          :key="item.id"
          :label="item.name"
          :value="item.id"
        ></el-option>
      </el-select>
      <el-button
        icon="el-icon-delete"
        @click="RemoveCategory"
        class="btn-deleteCategory"
      ></el-button>
      <!-- end -->

      <el-date-picker
        class="ml-10"
        @change="changeVerifyFilter"
        v-model="datePicker"
        value-format="yyyy-MM-ddTHH:mm:ss"
        format="dd-MM-yyyy"
        type="daterange"
        range-separator="-"
        start-placeholder="Start date"
        end-placeholder="End date"
        :default-time="['00:00:00', '23:59:59']"
      ></el-date-picker>
    </el-card>
    <el-card v-if="not_found">
      <not-found />

    </el-card>
    <el-card
      v-else
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <div class="card-header"></div>
      <el-table
        @row-click="showDetail"
        rowClassName="job-row pointer-row"
        :data="list"
      >
        <el-table-column
          fixed
          prop="id"
          label="ID"
          width="70"
        ></el-table-column>
        <el-table-column
          fixed
          prop="date"
          label="Logo"
          width="120"
        >
          <template slot-scope="scope">
            <img
              @click="showAvatar(scope.row.logo ? scope.row.logo.url : null, $event)"
              class="img-responsive"
              :src="(scope.row.logo && scope.row.logo.url) ? scope.row.logo.url :$store.state.imgHolder"
            />
          </template>
        </el-table-column>
        <el-table-column
          prop="position"
          label="Position"
          min-width="100"
        ></el-table-column>
        <el-table-column
          prop="workplace.company.name"
          label="Company Name"
          min-width="150"
        ></el-table-column>
        <el-table-column
          prop="category.name"
          label="Category"
          min-width="100"
        ></el-table-column>
        <el-table-column
          prop="workplace.address.city"
          label="City"
          min-width="150"
        ></el-table-column>
        <el-table-column
          prop="last_post.status"
          type
          label="Last Post"
          min-width="150"
        >
          <template slot-scope="scope">
            <el-tag
              type="info"
              size="small"
              v-if="!scope.row.last_post"
              min-width="60"
            >None</el-tag>
            <el-tag
              v-else
              size="small"
              type
              min-width="60"
            >{{$helper.replaceUnderscore(scope.row.last_post.status)}}</el-tag>
          </template>
        </el-table-column>
        <el-table-column
          prop="status"
          label="Status"
          min-width="150"
        >
          <template slot-scope="scope">
            <div
              v-if="scope.row.status"
              style
            >
              <el-tag
                v-if="scope.row.status == 'complete'"
                style="min-width: 100px; text-align:center;"
                size="small"
                type="success"
                class="font-weight-500"
              >{{$helper.replaceUnderscore(scope.row.status)}}</el-tag>
              <el-tag
                v-else
                style="min-width: 100px; text-align:center;"
                size="small"
                type="info"
                class="font-weight-500"
              >{{$helper.replaceUnderscore(scope.row.status)}}</el-tag>
            </div>
          </template>
        </el-table-column>
        <!--<el-table-column-->
        <!--fixed="right"-->
        <!--label="Action"-->
        <!--width="70"-->
        <!--align="center"-->
        <!--&gt;-->
        <!--<template slot-scope="scope">-->
        <!--<div class="custom-action-row">-->
        <!--<el-button class="btn-eye" @click="showDetail(scope.row.id,$event)"><i class="mdi mdi-eye "></i></el-button>-->
        <!--</div>-->
        <!--</template>-->
        <!--</el-table-column>-->
      </el-table>
      <div
        class="flex justify-space-between"
        style="align-items:center;"
      >
        <span>Total items: {{total}}</span>
        <el-pagination
          v-if="total > pageSize"
          class="right"
          background
          layout="prev, pager, next"
          style="margin-top: 20px"
          :current-page="currentPage"
          :page-size="pageSize"
          @current-change="onChangePage"
          :total="total"
        ></el-pagination>
      </div>
    </el-card>
    <view-image
      :dialogvisible.sync="dialogvisible"
      :imageUrl.sync="imageUrl"
    ></view-image>
  </div>
</template>
<script>
import ViewImage from "~/components/dialogs/ViewImage";
import Affix from "@/components/Affix";
import { job as jobApi, category as categoryApi } from "~/services/apis/index";
import helper from "~/services/helper";
import NotFound from '../ContentNotFound'
export default {
  name: "Table",
  data () {
    return {
      search: "",
      affixEnabled: true,
      list: [],
      loading: true,
      currentPage: 1,
      total: 0,
      status: "",
      has_activated_post: "",
      workplace_id: "",
      pageSize: this.$store.state.itemPerPage,
      defaultFilter: {},
      sortBy: "",
      dir: "",
      dialogvisible: false,
      not_found: false,
      imageUrl: null,
      verifyOptions: [
        {
          value: "all",
          label: "All"
        },
        {
          value: "complete",
          label: "Completed"
        },
        {
          value: "1",
          label: "Has activated Post"
        }
      ],
      verifyValue: "all",
      datePicker: "",
      from_date: "",
      to_date: "",
      categories: [
        {
          id: "all",
          name: "All category"
        },
        {
          id: 0,
          name: "None"
        }
      ],
      category_id: "",
      category_ids: ""
    };
  },
  components: {
    NotFound,
    ViewImage,
    Affix
  },
  computed: {
    onSubmit () {
      return this.$store.state.searchSubmit;
    },
  },
  watch: {
    onSubmit () {
      this.onSearch();
    },

    "$route.query" () {
      this.initParams();
      this.getListData();
    }
  },
  methods: {
    // remove
    RemoveCategory () {
      this.category_ids = [];
      this.$route.query.category_ids = [];
      this.updateRoute(this.$route.query);
    },
    //  get category
    getListCategory () {
      this.Loading = true;
      categoryApi
        .getCategories()
        .then(res => {
          if (res.data.success) {
            // res.data.data.filter(e => {
            //   if (e.id == this.$route.query.category_ids) {
            //     this.categories = [...this.category_ids, ...res.data.data];
            //     // this.category_ids = [...e.id];
            //   }
            // });
            this.categories = [...this.categories, ...res.data.data];
            this.Loading = false;
          }
        })
        .catch(error => {
          this.Loading = false;
        });
    },

    getListData () {
      this.loading = true;
      jobApi
        .getJobs(
          this.currentPage,
          this.pageSize,
          this.sortBy,
          this.dir,
          this.status,
          this.workplace_id,
          this.has_activated_post,
          this.from_date,
          this.to_date,
          this.search,
          this.category_ids
        )
        .then(res => {
          this.list = res.data.data;
          this.initData();
          this.loading = false;
          this.total = parseInt(res.headers["x-total-count"]);
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot get data from server!",
            type: "error"
          });
          this.loading = false
          this.not_found = true
        })
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;

      this.$router.push("jobs/" + row.id);
    },
    initParams () {
      const routeQuery = this.$route.query;
      if (!routeQuery.from_date && !routeQuery.to_date) {
        this.datePicker = "";
      } else if (!routeQuery.status) {
        this.status = "";
      } else if (!routeQuery.has_activated_post) {
        this.has_activated_post = "";
      }
      if (!this.$route.query) return;
      this.currentPage = routeQuery.page
        ? this.$helper.formatPage(routeQuery.page)
        : 1;
      this.sortBy = routeQuery.sort ? routeQuery.sort : null;
      this.dir = routeQuery.dir ? routeQuery.dir : null;

      this.verifyValue =
        routeQuery.status == "complete"
          ? (this.status = routeQuery.status)
          : routeQuery.has_activated_post == 1
            ? (this.has_activated_post = routeQuery.has_activated_post)
            : "all";
      this.from_date = this.$route.query.from_date
        ? this.$route.query.from_date
        : null;
      this.to_date = this.$route.query.to_date
        ? this.$route.query.to_date
        : null;
      if (this.from_date && this.to_date && !this.datePicker) {
        this.datePicker = [this.from_date, this.to_date];
      }
      if (!routeQuery.category_ids) {
        this.category_ids = [];
      } else {
        let tempArr = [];
        let Tempcategory_ids = this.$route.query.category_ids;
        for (let i = 0; i < Tempcategory_ids.length; i++) {
          let tempNum = Number(Tempcategory_ids[i]);
          if (tempNum >= 0) {
            tempArr.push(tempNum);
          }
        }
        let tempRemoveNum = Array.from(new Set(tempArr));
        this.category_ids = tempRemoveNum;
      }

      this.search = routeQuery.q ? routeQuery.q : "";
      this.$store.commit("setSearchValue", this.search);
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page);
      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      this.updateRoute(sQuery);
    },
    updateRoute (query) {
      this.$router.replace({ query: { page: 0 } });
      this.$router.replace({ name: "jobs", query: query });
    },

    changeVerifyFilter (value) {
      //eslint-disable-next-line
      this.currentPage = 1;
      let sQuery = {};
      sQuery.page = this.currentPage;
      if (value) {
        switch (value) {
          case "all":
            this.verifyValue = value;
            break;
          case "complete":
            this.verifyValue = value;
            this.status = this.verifyValue;
            sQuery.status = this.verifyValue;

            break;
          case "1":
            this.verifyValue = value;
            this.has_activated_post = this.verifyValue;
            sQuery.has_activated_post = this.verifyValue;
            break;
          default:
          // isNaN(value)
          //   ? (sQuery.category_id = this.category_id)
          //   : (sQuery.category_id = value);
        }
        if (this.datePicker && this.datePicker.length === 2) {
          this.from_date = this.datePicker[0];
          this.to_date = this.datePicker[1];
        }
        if (this.verifyValue && this.verifyValue === "all") {
          this.status = "";
          this.has_activated_post = "";
          sQuery.status = this.verifyValue;
        }
        if (this.verifyValue && this.verifyValue === "complete") {
          this.status = "complete";
          this.has_activated_post = "";
          sQuery.status = this.verifyValue;
        }
        if (this.verifyValue && this.verifyValue === "1") {
          this.status = "";
          this.has_activated_post = "1";
          sQuery.has_activated_post = this.verifyValue;
        }
        sQuery.from_date = this.from_date;
        sQuery.to_date = this.to_date;
        sQuery.category_ids = this.category_ids;
        sQuery.q = this.search;

        this.updateRoute(sQuery);
      }
      if (!value) {
        this.datePicker = "";
        this.verifyValue && this.verifyValue === "complete"
          ? (this.status = sQuery.status = "complete")
          : "all";
        this.verifyValue && this.verifyValue === "1"
          ? (this.has_activated_post = sQuery.has_activated_post = "1")
          : "all";
        // sQuery.name = this.name;
        sQuery.category_ids = this.category_ids;
        sQuery.q = this.search;
        this.updateRoute(sQuery);
        return;
      }
    },

    CategoryFillter (value) {
      this.currentPage = 1;
      let sQuery = {};
      sQuery.page = this.currentPage;
      if (this.datePicker && this.datePicker.length === 2) {
        this.from_date = this.datePicker[0];
        this.to_date = this.datePicker[1];
      }
      if (this.verifyValue && this.verifyValue === "all") {
        this.status = "";
        this.has_activated_post = "";
        sQuery.status = this.verifyValue;
      }
      if (this.verifyValue && this.verifyValue === "complete") {
        this.status = "complete";
        this.has_activated_post = "";
        sQuery.status = this.verifyValue;
      }
      if (this.verifyValue && this.verifyValue === "1") {
        this.status = "";
        this.has_activated_post = "1";
        sQuery.has_activated_post = this.verifyValue;
      }
      sQuery.from_date = this.from_date;
      sQuery.to_date = this.to_date;

      sQuery.q = this.search;
      sQuery.category_ids = value;
      this.updateRoute(sQuery);
      //choose all category
      let tempAll = false;
      for (let i = 0; i < this.category_ids.length; i++) {
        if (this.category_ids[i] == "all") {
          tempAll = true;
        }
      }
      if (tempAll == true) {
        for (let i = 0; i < this.categories.length; i++) {
          sQuery.category_ids.push(this.categories[i].id);
          var searchArr = sQuery.category_ids;
          var deleteElement = searchArr.indexOf("all");
          if (deleteElement != -1) {
            var affterDelete = searchArr.splice(deleteElement, 1);
            affterDelete.push(this.categories[i].id);

          }
        }
        this.updateRoute(sQuery);
      }
    },
    onSearch () {
      this.search = this.$store.state.search;
      this.currentPage = 1;

      let sQuery = {};

      sQuery.page = this.currentPage;
      sQuery.category_id = this.category_id;
      if (this.verifyValue && this.verifyValue === "all") {
        this.status = "";
        this.has_activated_post = "";
        sQuery.status = this.verifyValue;
      }
      if (this.verifyValue && this.verifyValue === "complete") {
        this.status = "complete";
        this.has_activated_post = "";
        sQuery.status = this.verifyValue;
      }
      if (this.verifyValue && this.verifyValue === "1") {
        this.status = "";
        this.has_activated_post = "1";
        sQuery.has_activated_post = this.verifyValue;
      }
      sQuery.from_date = this.from_date;
      sQuery.to_date = this.to_date;
      sQuery.category_ids = this.category_ids;
      sQuery.q = this.q;
      sQuery.q = this.search;

      this.updateRoute(sQuery);
      this.$store.commit("setSearchValue", this.search);
    },
    initData () {
      this.list.map((item, index) => {
        let { salary_from, salary_to } = item;

        this.$set(
          this.list[index],
          "salary_from",
          helper.formatNumber(salary_from)
        );
        this.$set(
          this.list[index],
          "salary_to",
          helper.formatNumber(salary_to)
        );
      });
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    }
  },
  created () {
    this.getListCategory();
  },

  mounted () {
    this.initParams();
    this.getListData();
    //this.getListCategory()
  }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";
.btn-deleteCategory {
  border-left: 0px;
  border-radius: 0px;
  z-index: 10px;
  margin-left: -2px;
  display: inline-flex;
}
.categoryfillter {
  padding-left: 10px;
  min-width: 300px;
  border-right: 0px;
}
.table-box {
  overflow: auto;
}

.min-width100 {
  min-width: 100px;
}

.min-width150 {
  min-width: 150px;
}

.min-width200 {
  min-width: 200px;
}

.text-center {
  padding: 10px;
}

table.styled tbody tr td {
  padding: 10px;
  font-size: 14px;
}

.btn-eye {
  padding: 1px 6px;
}
</style>

